local start, max, starttime, startlevel
local playedTime = 0
local playedLevel = 0

local rwPlayerStats = CreateFrame("frame")
rwPlayerStats:SetScript("OnEvent", function(self, event, ...) if self[event] then return self[event](self, event, ...) end end)
local dataobj = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("rwPlayerStats", {type = "data source", label="rwPlayerStats", text = ""})

rwPlayerStatsDB = rwPlayerStatsDB or { percent = true, rested = true, name = false }

local rwPlayerStats_BarHeight = 0.15

local rwPlayerStats_XPBar = CreateFrame("Frame", nil, BazookaPlugin_rwPlayerStats)
local tex = rwPlayerStats_XPBar:CreateTexture(nil,"OVERLAY")
tex:SetTexture("Interface\\AddOns\\rwPlayerStats\\bar.tga")
tex:SetVertexColor(0,0,1,1)
tex:SetAllPoints(rwPlayerStats_XPBar)
rwPlayerStats_XPBar.texture = tex
rwPlayerStats_XPBar:SetPoint("BOTTOMLEFT", BazookaPlugin_rwPlayerStats, "BOTTOMLEFT", 0, 0)
rwPlayerStats_XPBar:SetFrameStrata("TOOLTIP")

local rwPlayerStats_RestBar = CreateFrame("Frame", nil, BazookaPlugin_rwPlayerStats)
tex = rwPlayerStats_RestBar:CreateTexture(nil,"OVERLAY")
tex:SetTexture("Interface\\AddOns\\rwPlayerStats\\bar.tga")
tex:SetVertexColor(0.85,0,0.85,1)
tex:SetAllPoints(rwPlayerStats_RestBar)
rwPlayerStats_RestBar.texture = tex
rwPlayerStats_RestBar:SetPoint("BOTTOMLEFT", BazookaPlugin_rwPlayerStats, "BOTTOMLEFT", 0, 0)
rwPlayerStats_RestBar:SetFrameStrata("TOOLTIP")

local rwPlayerStats_ToGoBar = CreateFrame("Frame", nil, BazookaPlugin_rwPlayerStats)
tex = rwPlayerStats_ToGoBar:CreateTexture(nil,"OVERLAY")
tex:SetTexture("Interface\\AddOns\\rwPlayerStats\\bar.tga")
tex:SetVertexColor(0.75,0.6,0.5,1)
tex:SetAllPoints(rwPlayerStats_ToGoBar)
rwPlayerStats_ToGoBar.texture = tex
rwPlayerStats_ToGoBar:SetPoint("BOTTOMLEFT", BazookaPlugin_rwPlayerStats, "BOTTOMLEFT", 0, 0)
rwPlayerStats_ToGoBar:SetFrameStrata("TOOLTIP")

function rwPlayerStats:PLAYER_LOGIN()
	start, max, starttime = UnitXP("player"), UnitXPMax("player"), GetTime()
	startlevel = UnitLevel("player") + start/max

	self:RegisterEvent("PLAYER_XP_UPDATE")
	self:RegisterEvent("PLAYER_LEVEL_UP")
	self:RegisterEvent("TIME_PLAYED_MSG")

	RequestTimePlayed()
	
	self:PLAYER_XP_UPDATE()
	self:UnregisterEvent("PLAYER_LOGIN")
	self.PLAYER_LOGIN = nil
end

function rwPlayerStats:TIME_PLAYED_MSG(_, t, l)
	playedTime = t
	playedLevel = l
end

function rwPlayerStats:PLAYER_XP_UPDATE()
	local level = UnitLevel("player")
	local msg = ""
	
	local curXP = UnitXP("player")
	local maxXP = UnitXPMax("player")
	local restXP = GetXPExhaustion() or 0
	local restDisplay = restXP
	local togoXP = maxXP - curXP
	local level = UnitLevel("player")

	if restXP > maxXP - curXP then
		restXP = maxXP - curXP
	end

	local xpPercent = curXP/maxXP
	local restPercent = restXP/maxXP
	local togoPercent = maxXP - xpPercent - restPercent

	if rwPlayerStatsDB.name then
  	msg = UnitName("player")
  end
  msg = msg.." ("..level..")"
  
	if level < MAX_PLAYER_LEVEL then
	  msg = msg.." "..curXP.."/"..maxXP
	  if rwPlayerStatsDB.percent then
	  	msg = msg.." ("..floor(xpPercent*100).."%)"
	  end
	  if rwPlayerStatsDB.rested then
	  	msg = msg.." "..restXP.." rested"
	  end
	end
	dataobj.text = msg

	if BazookaPlugin_rwPlayerStats ~= nil then
		local frameWidth = BazookaPlugin_rwPlayerStats:GetWidth() * 0.9
		local xpWidth = frameWidth * xpPercent
		local restWidth = frameWidth * restPercent
		local togoWidth = frameWidth - xpWidth - restWidth
	
		rwPlayerStats_XPBar:Show()
		rwPlayerStats_XPBar:ClearAllPoints()
		rwPlayerStats_XPBar:SetWidth(xpWidth)
		rwPlayerStats_XPBar:SetHeight(BazookaPlugin_rwPlayerStats:GetHeight() * rwPlayerStats_BarHeight)
		rwPlayerStats_XPBar:SetPoint("BOTTOMLEFT", BazookaPlugin_rwPlayerStats, "BOTTOMLEFT", 0, 0)
	
		if restXP > 0 then
			rwPlayerStats_RestBar:Show()
			rwPlayerStats_RestBar:ClearAllPoints()
			rwPlayerStats_RestBar:SetWidth(restWidth)
			rwPlayerStats_RestBar:SetHeight(BazookaPlugin_rwPlayerStats:GetHeight() * rwPlayerStats_BarHeight)
			rwPlayerStats_RestBar:SetPoint("BOTTOMLEFT", BazookaPlugin_rwPlayerStats, "BOTTOMLEFT", xpWidth, 0)
		else
			rwPlayerStats_RestBar:Hide()
		end
	
		if restXP > togoXP then
			rwPlayerStats_ToGoBar:Hide()
		else
			rwPlayerStats_ToGoBar:Show()
			rwPlayerStats_ToGoBar:ClearAllPoints()
			rwPlayerStats_ToGoBar:SetWidth(togoWidth)
			rwPlayerStats_ToGoBar:SetHeight(BazookaPlugin_rwPlayerStats:GetHeight() * rwPlayerStats_BarHeight)
			rwPlayerStats_ToGoBar:SetPoint("BOTTOMLEFT", BazookaPlugin_rwPlayerStats, "BOTTOMLEFT", restWidth + xpWidth, 0)
		end
	end
end

function rwPlayerStats:PLAYER_LEVEL_UP()
	start = start - max
	max = UnitXPMax("player")
end

local function GetTipAnchor(frame)
	local x,y = frame:GetCenter()
	if not x or not y then return "TOPLEFT", "BOTTOMLEFT" end
	local hhalf = (x > UIParent:GetWidth()*2/3) and "RIGHT" or (x < UIParent:GetWidth()/3) and "LEFT" or ""
	local vhalf = (y > UIParent:GetHeight()/2) and "TOP" or "BOTTOM"
	return vhalf..hhalf, frame, (vhalf == "TOP" and "BOTTOM" or "TOP")..hhalf
end

function dataobj.OnLeave() GameTooltip:Hide() end

function dataobj.OnEnter(self)
 	GameTooltip:SetOwner(self, "ANCHOR_NONE")
	GameTooltip:SetPoint(GetTipAnchor(self))
	GameTooltip:ClearLines()

	GameTooltip:AddLine("rwPlayerStats")

	local baseArmor, effectiveArmor, fullArmor, posBuff, negBuff = UnitArmor("player")
	local cur = UnitXP("player")
	local sessionPlayed = GetTime() - starttime
	local il1, il2 = GetAverageItemLevel()
	local il = string.format("%.1f/%.1f", il1, il2)
	
	GameTooltip:AddDoubleLine("Class",UnitClass('player'), 1,1,1)
	GameTooltip:AddLine(string.format("%.1f hours played this session", (sessionPlayed)/3600), 1,1,1)
	GameTooltip:AddLine(string.format("%.1f hours played this level", (playedLevel + sessionPlayed)/3600), 1,1,1)
	GameTooltip:AddLine(string.format("%.1f hours played in total", (playedTime + sessionPlayed)/3600), 1,1,1)
	GameTooltip:AddLine((cur - start).." EXP gained this session", 1,1,1)
	GameTooltip:AddLine(string.format("%.1f levels gained this session", UnitLevel("player") + cur/max - startlevel), 1,1,1)
	GameTooltip:AddLine(" ")
	GameTooltip:AddDoubleLine("Item Level", il, 1,1,1)
	GameTooltip:AddLine(" ")
	GameTooltip:AddLine("Armor", 1,1,1)
	GameTooltip:AddDoubleLine("    Base",baseArmor, 1,1,1)
	GameTooltip:AddDoubleLine("    Effective",effectiveArmor, 1,1,1)
	GameTooltip:AddDoubleLine("    Full",fullArmor, 1,1,1)
	GameTooltip:AddLine(" ")
	GameTooltip:AddLine("Base Stats", 1,1,1)
	GameTooltip:AddDoubleLine("    Strength",UnitStat("player", 1), 1,1,1)
	GameTooltip:AddDoubleLine("    Agility",UnitStat("player", 2), 1,1,1)
	GameTooltip:AddDoubleLine("    Stamina",UnitStat("player", 3), 1,1,1)
	GameTooltip:AddDoubleLine("    Intellect",UnitStat("player", 4), 1,1,1)
	GameTooltip:AddLine(" ",1,1,1)
	GameTooltip:AddLine("Click to open the character window.",1,1,1)
	GameTooltip:AddLine("Shift-Click to toggle name display.",1,1,1)
	GameTooltip:AddLine("Alt-Click to toggle rested display.",1,1,1)
	GameTooltip:AddLine("Ctrl-Click to toggle percent display.",1,1,1)

	GameTooltip:Show()
end

function dataobj.OnClick()
	local alt = IsAltKeyDown()
	local shft = IsShiftKeyDown()
	local ctrl = IsControlKeyDown()
	
	if alt then rwPlayerStatsDB.rested = not rwPlayerStatsDB.rested end
	if ctrl then rwPlayerStatsDB.percent = not rwPlayerStatsDB.percent end
	if shft then rwPlayerStatsDB.name = not rwPlayerStatsDB.name end

	if not alt and not ctrl and not shft then
		ToggleCharacter("PaperDollFrame")
	end

	rwPlayerStats:PLAYER_XP_UPDATE()
end

if IsLoggedIn() then rwPlayerStats:PLAYER_LOGIN() else rwPlayerStats:RegisterEvent("PLAYER_LOGIN") end
